/*
 *  This program creates a local header file, local.h, which contains
 *  information enabling libckpt to be compiled.  This program is compiled
 *  and run automatically by compiling libckpt using the Makefile provided
 *  with the source distribution.
 */

#include <stdio.h>
#include <signal.h>
#include <sys/time.h>
#include <sys/resource.h>

FILE *f;

#ifdef sparc
char *ptr;

void
pgfault_handler(sig, code, scp, addr)
long sig, code;
struct sigcontext *scp;
char *addr;
{
  fprintf(f, "#define BOTTOM_STACK ((unsigned long)(0x%p))\n",ptr - 1);
  fclose(f);
  exit(0);
}
#endif /* sparc */

main()
{

  int stack_dummy;
  struct rlimit rlim;

  f = fopen("local.h", "w");

#ifdef __mips
  rlim.rlim_max = 64;
#else
  getrlimit(RLIMIT_NOFILE, &rlim);
#endif

  fprintf(f, "#define _CKPT_FTABLE_SIZE %d\n", rlim.rlim_max);

#ifndef __hppa
  fprintf(f, "#define GPAGESIZE ((unsigned long)(%d))\n", getpagesize());
#endif

#ifdef sparc

  fprintf(f, "#define FILE_AREA (char *)0x%p\n",f);
  fprintf(f, "#define FILE_AREA_SIZE 0x244\n");

  signal(SIGSEGV, pgfault_handler);

  ptr = (char *)&stack_dummy;

  /* program calls exit(0) from signal handler */

  while (1) {
    *ptr = 0;
    ptr += 1;
  }

#else /* sparc */
  
  fclose(f);
  exit(0);

#endif /* sparc */

}

