#ifndef LIBCKPT_H
#define LIBCKPT_H

#include "copyright.h"

#include <stdio.h>
#include <setjmp.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <sys/param.h>
#include <sys/wait.h>
#include <signal.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <dirent.h>
#include <varargs.h>

#ifndef _SGI_SOURCE
#include <sys/syscall.h>	/* don't include this file on SGI machines */
#endif

#ifndef SYSTEM_C		/* don't include these two                 */
#include <unistd.h>             /* files in system.c                       */
#include <fcntl.h>
#endif /* SYSTEM_C */

#include "local.h"
#include "dlist.h"
#include "machdep.h"
#include "checkpoint.h"
#include "typedefs.h"
#include "prototypes.h"
#include "externs.h"

/* char *sbrk(); */

#define TRUE		1
#define FALSE		0
#define OFFSET		100
#define NUM_FLAGS	10     /* number of flags setable from .ckptrc     */

#define max(x,y)        (((x) < (y)) ? (y) : (x))
#define min(x,y)        (((x) < (y)) ? (x) : (y))

#define CKPT_ALLOW 	0
#define CKPT_DISALLOW	1
#define CKPT_DELAY 	2

#define CKPT_MUTEX_GET { _ckpt_mutex = CKPT_DISALLOW; }
#define CKPT_MUTEX_REL \
	{ if (_ckpt_mutex == CKPT_DELAY) checkpoint_here(); \
	  _ckpt_mutex = CKPT_ALLOW; }

#ifdef _SGI_SOURCE
#define OPEN(fname,oflag)		_open((fname), (oflag))
#define OPEN_M(fname,oflag,mode)	_open((fname), (oflag), (mode))
#define CLOSE(fd)			_close((fd))
#define DUP(fd)				_dup((fd))
#define DUP2(fd1,fd2)			_dup2((fd1), (fd2))
#define READ(fd,buf,nbyte)		_read((fd), (buf), (nbyte))
#define WRITE(fd,buf,nbyte)		_write((fd), (buf), (nbyte))
#else
#define OPEN(fname,oflag)		syscall(SYS_open, (fname), (oflag))
#define OPEN_M(fname,oflag,mode)	syscall(SYS_open, (fname), (oflag), (mode))
#define CLOSE(fd)			syscall(SYS_close, (fd))
#define DUP(fd)				syscall(SYS_dup, (fd))
#define DUP2(fd1,fd2)			syscall(SYS_dup2, (fd1), (fd2))
#define READ(fd,buf,nbyte)		syscall(SYS_read, (fd), (buf), (nbyte))
#define WRITE(fd,buf,nbyte)		syscall(SYS_write, (fd), (buf), (nbyte))
#endif /* _SGI_SOURCE */

#endif /* LIBCKPT_H */
