#ifndef MACHDEP_H
#define MACHDEP_H

#include "copyright.h"

#ifdef  sparc
#define SEGSIZE         8192
#define START_ADDR      ((unsigned long)(((int)((int)&etext / SEGSIZE) + 1) * SEGSIZE))
#define TOP_STACK       ((unsigned long)((unsigned long)&dummy_last - OFFSET))
#define BADADDR         ((unsigned long)addr)
#define	POINTER_SIZE	4
#define STACK_GROWS_UP
#endif /* sparc */

#ifdef	__alpha
#define BOTTOM_STACK    ((unsigned long)0x120000000)
#define START_ADDR      ((unsigned long)0x140000000)
#define TOP_STACK       ((unsigned long)((unsigned long)(&dummy_first) - OFFSET))
#define BADADDR         ((unsigned long)(scp -> sc_traparg_a0))
#define	POINTER_SIZE	8
#define STACK_GROWS_UP
#endif /* __alpha */

#if defined(__mips) && !defined(_SGI_SOURCE)
#define BOTTOM_STACK    ((unsigned long)0x7fffbfff)
#define START_ADDR      ((unsigned long)0x10000000)
#define TOP_STACK       ((unsigned long)((unsigned long)(&dummy_first) - OFFSET))
#define BADADDR         ((unsigned long)(scp -> sc_badvaddr))
#define	POINTER_SIZE	4
#define STACK_GROWS_UP
#endif /* __mips && !_SGI_SOURCE */

#ifdef _SGI_SOURCE
#define BOTTOM_STACK	((unsigned long)0x7fffffff)
#define START_ADDR	((unsigned long)0x10000000)
#define TOP_STACK       ((unsigned long)((unsigned long)(&dummy_last) - OFFSET))
#define BADADDR         ((unsigned long)(scp -> sc_badvaddr))
#define	POINTER_SIZE	4
#define STACK_GROWS_UP
#endif /* __sgi */

#ifdef __hppa
#define BOTTOM_STACK    ((unsigned long)0x7b009000)
#define START_ADDR      ((unsigned long)0x40001000)
#define TOP_STACK       ((unsigned long)((unsigned long)(&dummy_last) - OFFSET))
#define BADADDR         ((unsigned long)(scp -> sc_sl.sl_ss.ss_gr19))
#define POINTER_SIZE    4
#define GPAGESIZE       ((unsigned long)(4096))
#define STACK_GROWS_DOWN
#endif /* __hppa */

#ifdef __linux
#define BOTTOM_STACK	((unsigned long)0xc0000000)
/*#define START_ADDR	((unsigned long)0x8000000)*/
#define START_ADDR	((unsigned long)(((int)((int)&etext / GPAGESIZE) + 1) * GPAGESIZE))
#define TOP_STACK	((unsigned long)((unsigned long)(&dummy_first) - OFFSET))
#define BADADDR
#define POINTER_SIZE	4
#define STACK_GROWS_UP
#endif


#endif /* MACHDEP_H */
