#include <stdio.h>
#include "checkpoint.h"

#define  N        300
#define  MAXSIZE  100

void read_matrix(/* int * */);
void mult_matrix(/* int * */);

ckpt_target(argc, argv)
int argc;
char **argv;
{

  int i;
  int *A;
  int *B;
  int num;
  int size;

  if (argc != 1) {
    fprintf(stderr,"Usage: %s\n",argv[0]);
    exit(-1);
  }

  size = N * N;

  A = (int *)malloc(sizeof(int) * size);
  B = (int *)malloc(sizeof(int) * size);

  if (!A || !B) {
    printf("not enough memory\n");
    exit(-1);
  }

  read_matrix(A);

  mult_matrix(A, B);

  free(A);
  free(B);

}

void
read_matrix(A)
int A[][N];
{

  int i,j;

  srand(1);

  for(i=0;i<N;i++)
    for(j=0;j<N;j++)
      A[i][j] = rand() % MAXSIZE;

}

void
mult_matrix(A, B)
int A[][N];
int B[][N];
{

  int i,j,k;
  int size;

  size = N * N;

  printf("initializing matrix B\n");

  for(i=0;i<N;i++)
    for(j=0;j<N;j++)
      B[i][j] = 0;

  printf("doing the multiplication B = A * A\n");

  for(i=0;i<N;i++) {
    for(j=0;j<N;j++)
      for(k=0;k<N;k++)
	B[i][j] += A[i][k] * A[k][j];
    if ( i % 40 == 0 ) {
      printf("row %d\n",i);
      checkpoint_here();
    }
  }

  printf("moving the result from matrix B to matrix A\n");

  for(i=0;i<N;i++)
    for(j=0;j<N;j++)
      A[i][j] = B[i][j];

}
