#ifndef PROTOTYPES_H
#define PROTOTYPES_H

#include "copyright.h"

#ifdef	__STDC__

/* functions in checkpoint.c */

#ifdef __mips
static void chld_handler();
#else
#ifdef __alpha
static void chld_handler();
#else
#ifdef __linux
static void chld_handler(int);
#else
static void chld_handler(void);
#endif
#endif
#endif

static int check_flags(void);
static void gseek(void);
static int take_ckpt(void);
static int write_header(int);
static int i_write_heap(int);
static int write_heap(int);
static int write_stack(int);
static int gsync(void);
static int write_chunk(char *, long, int);
static void open_files(void);
static int protect_all(void);
static int cleanup(int);
static int isnew(int);
static int isdirty(int);

/* functions in recover.c */

void ckpt_recover_(char *);
void _ckpt_recover(pname_type);

static int recover_heap(pname_type);
static void recover_stack(int, pname_type);
static void restore_memory(char *, int, pname_type);

/* functions in setup.c */

#ifdef __mips
void _ckpt_pgfault_handler();
void _ckpt_alrm_handler();
#else
#ifdef __alpha
void _ckpt_pgfault_handler();
void _ckpt_alrm_handler();
#else
#ifdef __linux
void _ckpt_alrm_handler(int);
#else
void _ckpt_pgfault_handler(long, long, struct sigcontext *, char *);
void _ckpt_alrm_handler(void);
#endif
#endif
#endif

static void print_defaults(void);

void ckpt_setup_(int *, char **);
void _ckpt_setup(int *, char **);

static void set_flags(int *, char **);
static void check_for_recovery(int *, char **);
static void set_defaults(void);
static void read_dotfile(char *);
static void init_flag_array(unsigned long []);
static int convert(char *, char *,int *, unsigned long *);
pname_type _ckpt_get_path(void);
static void check_files(void);
static void set_globals(void);
static void set_incremental(void);
static void set_alarm(void);
void _ckpt_markpage(unsigned long);
static int  isnum(char *);
int ckpt_name(char *);

/* functions in include.c */

static int include(Mlist, char *, unsigned long);
static void coalesce(Mlist , Dlist);
static int exclude(Mlist, char *, unsigned long);

/* functions in system.c */

/* int open(char *, int, int); */
/* int dup(int); */
/* int dup2(int, int); */
/* int close(int); */
static void file_insert(char *, int, int, int, int);
static void file_delete(int);
/* int read(int, char *, int); */
/* int write(int, char *, int); */

#else /* __STDC__ not defined */

/* functions in checkpoint.c */

static void chld_handler();
static int check_flags();
static void gseek();
static int take_ckpt();
static int write_header();
static int i_write_heap();
static int write_heap();
static int write_stack();
static int gsync();
static int write_chunk();
static void open_files();
static int protect_all();
static int cleanup();
static int isnew();
static int isdirty();

/* functions in recover.c */

void ckpt_recover_();
void _ckpt_recover();

static int recover_heap();
static void recover_stack();
static void restore_memory();

/* functions in setup.c */

void _ckpt_pgfault_handler();
void _ckpt_alrm_handler();

static void print_defaults();

void ckpt_setup_();
void _ckpt_setup();

static void set_flags();
static void check_for_recovery();
static void set_defaults();
static void read_dotfile();
static void init_flag_array();
static int convert();
pname_type _ckpt_get_path();
static void check_files();
static void set_globals();
static void set_incremental();
static void set_alarm();
void _ckpt_markpage();
static int  isnum();
int ckpt_name();

/* functions in include.c */

static int include();
static void coalesce();
static int exclude();

/* functions in system.c */

/* int open(); */
/* int dup(); */
/* int dup2(); */
/* int close(); */
static void file_insert();
static void file_delete();
/* int read(); */
/* int write(); */

#endif /* __STDC__ */
#endif /* PROTOTYPES_H */
